/*   Project 3
     Author:   Thom branning
     Problem -- Merge two input lists
*/
#include <stdio.h>
#define DESCEND  0

/*  define function to merge two lists into one */
void merge_lists(arraya, arrayb, arrayc, enda, endb)
int arraya[], arrayb[], arrayc[];
int enda, endb;
{
  int count = 1;
  int inx1 =0, inx2 = 0, inx3 = 0;

  /*  process and merge data from arrays A and B into C */
  for(  ;inx3 < 20 && inx1 < enda && inx2 < endb;)
       {
        #if(DESCEND)
          {
           if(arraya[inx1] > arrayb[inx2])
              arrayc[inx3++] = arraya[inx1++];
           else
              arrayc[inx3++] = arrayb[inx2++];
          }
        #else
          {
           if(arraya[inx1] < arrayb[inx2])
              arrayc[inx3++] = arraya[inx1++];
           else
              arrayc[inx3++] = arrayb[inx2++];
          }
       #endif
       }

/* Load whatever is left in these lists */
  while(inx1 < enda)
            arrayc[inx3++] = arraya[inx1++];

  while(inx2 < endb)
            arrayc[inx3++] = arrayb[inx2++];
 }
                                                       	
main ()
{
   /* declare variables for main program use */
   int nums1[10], nums2[10], nums3[20];
   int *arrayptr, endnum1, endnum2 ;
   int list, temp, counter, index;
   char edit = 'Y';

/* Set arrays to 0 */
   for(index = 0;index < 10;index++)
      nums1[index] = nums2[index] = nums3[index] = nums3[index + 10] = 0;

/* Read in two lists and process */
   temp = 0;
   list = 1;
   while(temp <= 0 && list <=2 )
   {
       scanf("%d,",&temp);
       if(temp <= 0)
         list += 1;
   }

/* Go thru 2 lists and ensure both are valid to process. */
   while(list <= 2 && edit == 'Y')
   {
     if(list == 1)
       arrayptr = nums1;
     else
       arrayptr = nums2;
     counter = 1;

     for(; edit == 'Y' && temp > 0;)
      {
       *arrayptr = temp;
       scanf("%d,",&temp);
       counter +=1;

       if(temp > 0)
        {

        /* edit to enusre in proper order */
         if((DESCEND && (temp > *arrayptr)) || (!(DESCEND) && temp < *arrayptr))
          {
            edit = 'N';
            printf("\n All input not sorted - abort");
          }

        /* edit to be sure that too many numbers have not been entered */
         if(counter > 10)
           {
             edit = 'N';
             printf("\n Two many numbers in list - abort");
           }
        } /* if temp > 0 */

/* increment pointer to next element */
      arrayptr += 1;

     } /* for end */

   if(list == 1)
     {
      endnum1 = counter - 1;
      scanf("%d,",&temp);
     }
   else
      endnum2 = counter - 1;
    list +=1;
 } /*while list <=2 */

/* Call function to put both lists 1 and 2 into 3 */
merge_lists(nums1, nums2, nums3, endnum1, endnum2);

/* print out contents of list 3 */
for(index = 0; index < 20 && nums3[index] > 0 ;index++)
   printf("\n Number %d is %d.",index,nums3[index]);
} /* end main */
